// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from ros_ign_interfaces:msg/WorldControl.idl
// generated code does not contain a copyright notice
#include "ros_ign_interfaces/msg/detail/world_control__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `reset`
#include "ros_ign_interfaces/msg/detail/world_reset__functions.h"
// Member `run_to_sim_time`
#include "builtin_interfaces/msg/detail/time__functions.h"

bool
ros_ign_interfaces__msg__WorldControl__init(ros_ign_interfaces__msg__WorldControl * msg)
{
  if (!msg) {
    return false;
  }
  // pause
  // step
  // multi_step
  msg->multi_step = 0ul;
  // reset
  if (!ros_ign_interfaces__msg__WorldReset__init(&msg->reset)) {
    ros_ign_interfaces__msg__WorldControl__fini(msg);
    return false;
  }
  // seed
  // run_to_sim_time
  if (!builtin_interfaces__msg__Time__init(&msg->run_to_sim_time)) {
    ros_ign_interfaces__msg__WorldControl__fini(msg);
    return false;
  }
  return true;
}

void
ros_ign_interfaces__msg__WorldControl__fini(ros_ign_interfaces__msg__WorldControl * msg)
{
  if (!msg) {
    return;
  }
  // pause
  // step
  // multi_step
  // reset
  ros_ign_interfaces__msg__WorldReset__fini(&msg->reset);
  // seed
  // run_to_sim_time
  builtin_interfaces__msg__Time__fini(&msg->run_to_sim_time);
}

ros_ign_interfaces__msg__WorldControl *
ros_ign_interfaces__msg__WorldControl__create()
{
  ros_ign_interfaces__msg__WorldControl * msg = (ros_ign_interfaces__msg__WorldControl *)malloc(sizeof(ros_ign_interfaces__msg__WorldControl));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ros_ign_interfaces__msg__WorldControl));
  bool success = ros_ign_interfaces__msg__WorldControl__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
ros_ign_interfaces__msg__WorldControl__destroy(ros_ign_interfaces__msg__WorldControl * msg)
{
  if (msg) {
    ros_ign_interfaces__msg__WorldControl__fini(msg);
  }
  free(msg);
}


bool
ros_ign_interfaces__msg__WorldControl__Sequence__init(ros_ign_interfaces__msg__WorldControl__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  ros_ign_interfaces__msg__WorldControl * data = NULL;
  if (size) {
    data = (ros_ign_interfaces__msg__WorldControl *)calloc(size, sizeof(ros_ign_interfaces__msg__WorldControl));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ros_ign_interfaces__msg__WorldControl__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ros_ign_interfaces__msg__WorldControl__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ros_ign_interfaces__msg__WorldControl__Sequence__fini(ros_ign_interfaces__msg__WorldControl__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ros_ign_interfaces__msg__WorldControl__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ros_ign_interfaces__msg__WorldControl__Sequence *
ros_ign_interfaces__msg__WorldControl__Sequence__create(size_t size)
{
  ros_ign_interfaces__msg__WorldControl__Sequence * array = (ros_ign_interfaces__msg__WorldControl__Sequence *)malloc(sizeof(ros_ign_interfaces__msg__WorldControl__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = ros_ign_interfaces__msg__WorldControl__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
ros_ign_interfaces__msg__WorldControl__Sequence__destroy(ros_ign_interfaces__msg__WorldControl__Sequence * array)
{
  if (array) {
    ros_ign_interfaces__msg__WorldControl__Sequence__fini(array);
  }
  free(array);
}
